
/*
 * Copyright (c) Developers of Binary Utility
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 *      <date>			        <changed by>		<summary of changes>
 * 26 November 2004  	    Jonee Ryan Ty		First documented history
 *
 */

#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

	// if MY_VERSION is not zero, it would overwrite an existing file
#define MY_VERSION 0
enum boolean {FALSE = 0, TRUE};

int error = FALSE;

int main(int argc, char* argv[]) {

	FILE *outFile;
	int i = 0, exists(char *), size1 = 0, size2 = 0, outputExists = FALSE;
	char *file1, *file2, *myRead(char *, int *);

	if (argc != 4) {	// check for parameter count
		fprintf(stderr, "three parameters expected\n");
		fprintf(stderr, "<outfile> <file1> <file2>\n");
		exit(1);
	}

	for (; i < 2; i++) { // check whether the two input files exist
		if (!exists(argv[i + 2])) {
			fprintf(stderr, "file does not exist: %s\n", argv[i + 2]);
			error = TRUE;
		}
	}

	if (exists(argv[1])) { // if output file exists
		outputExists = TRUE;

		if (!MY_VERSION) {
			fprintf(stderr, "file exists: %s\n", argv[1]);
			error = TRUE;
		}
	}

	if ((strcmp(argv[1], argv[2]) == 0) || (strcmp(argv[1], argv[3]) == 0)) {
		fprintf(stderr, "input file same as output\n");
		error = TRUE;
	}

	if (error)
		exit(1);

		/* read the files into the arrays and wrte to the output file */
	outFile = fopen(argv[1], "w");

	file1 = myRead(argv[2], &size1);

	if (file1 != NULL) {
		fwrite(file1, 1, size1, outFile);
		free(file1);

		file2 = myRead(argv[3], &size2);

		if (file2 != NULL) {
			fwrite(file2, 1, size2, outFile);
			free(file2);
		}
	}

	fclose(outFile);
}

/**
 * check whether the file exists
 */
int exists(const char *outFileName) {
	FILE *tmp;
	tmp = fopen(outFileName, "r");

	if (tmp != NULL) {
		fclose(tmp);
		return TRUE;
	}

	return FALSE;
}

/**
 * read the file into a character array res, returns the character array (or NULL on error)
 * stores the size (or -1 on file descriptor error) on given parameter int pointer
 */
char *myRead(const char *fileName, int *size) {

	int fd;
	char *res;

	struct stat st;

	stat(fileName, &st);

	if((fd = open(fileName, O_RDONLY)) == -1) {
		fprintf(stderr, "file descriptor error for %s\n", fileName);
		*size = -1;
		return NULL;
	}

	res = (char *)malloc(st.st_size);

	read(fd, res, st.st_size);
	close(fd);

	*size = st.st_size;

	return res;
}









