
/*
 * Copyright (c) Developers of Binary Utility
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 *      <date>			        <changed by>		<summary of changes>
 * 26 November 2004  	    Jonee Ryan Ty		First documented history
 *
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define MY_VERSION 0
enum boolean {FALSE = 0, TRUE};

int 	getHexVal(char c),
	error = FALSE;	//error flag


int main(int argc, char* argv[]) {

	FILE *outFile;
	char *outFileName, *hexStream, *result;
	int iTmp = 1, len, i = 0, v1, v2, size;
		/* check for parameter count */
	if ((argc == 1) || (argc > 3)) {
		fprintf(stderr, "wrong parameter count\n");
		fprintf(stderr, "[output file] hexString\n");
		exit(1);
	}
		/* if output file is not given, output is "bin" */
	if (argc == 3) {
		outFileName = argv[1];
		hexStream = argv[2];

	} else {
		hexStream = argv[1];
		outFileName = "bin";
	}

	if (exists(outFileName) && !MY_VERSION) {	// if output file exists
		fprintf(stderr, "file exists: %s\n", argv[1]);
		error = TRUE;
		exit(1);
	}

	len = strlen(hexStream);

	size =  len / 2;	// the number of bytes is half the number of hexes

	if (len % 2 == 1)
		size++;

	result = (char *)malloc(size);
		/* get two hexes at a time */
	for (; i < len; i = i + 2) {

		v1 = getHexVal(hexStream[i]);

		if (i + 1 == len) {
			v2 = 0;
		} else {
			v2 = getHexVal(hexStream[i + 1]);
		}

		iTmp = v1 * 16 + v2;

		if (error) {
			i = len;	// to terminate loop
		} else {
			result[i / 2] = iTmp;

		}
	}

	if (error) {
		exit(1);

	} else {
		outFile = fopen(outFileName, "w");
		fwrite(result, size, 1, outFile);
		fclose(outFile);
	}
}

/**
 * check whether the file exists
 */
int exists(const char *outFileName) {
	FILE *tmp;
	tmp = fopen(outFileName, "r");

	if (tmp != NULL) {
		fclose(tmp);
		return TRUE;
	}

	return FALSE;
}

/**
 * give value of parameter char. if char is numerical output is the number that that char represents. ie '1' -> 1.
 * if parameter is 'F' or 'f' output is 16 etc.
 */
int getHexVal(char c) {
	int hexVal = 0;
	if (isxdigit(c)) {
		if (isdigit(c)) {
			hexVal = c - '0';
		} else {
			if(isupper(c)) {
				hexVal = 10 + c - 'A';
			} else {
				hexVal = 10 + c - 'a';
			}
		}

	} else {
		fprintf(stderr, "non-hex char found: %c\n", c);
		error = TRUE;
	}
}
